#ifndef __DDRAW_H__
#define __DDRAW_H__

#include <windows.h>
#include <ddraw.h>

#define WINDOWED 0

class CDirectDraw
{
	IDirectDraw7 *lpDD;
	IDirectDrawSurface7* lpFrontBuffer;
	IDirectDrawSurface7* lpBackBuffer;
    LPDIRECTDRAW lpDD3;
    LPDIRECTDRAWSURFACE lpFrontBuffer3;
    LPDIRECTDRAWSURFACE lpBackBuffer3;
    int old;
    LPDIRECTDRAWCLIPPER lpClipper;
	int scrnX,scrnY,scrnDepth,inAWindow,allowFlip;
    int x1,x2,y1,y2;
	HWND hWnd;
public:
	CDirectDraw(HWND _hWnd,int sx,int sy,int depth,bool old=false);
	~CDirectDraw();
    void ChangeResolution(HWND _hWnd,int sx,int sy,int depth);
    IDirectDraw7* GetDD();
    LPDIRECTDRAW GetDD3();
	void Update();
	int GetScrnX();
	int GetScrnY();
	int GetScrnDepth();
	HWND GetWindow();
	void BeginGDI();
	void EndGDI();
	IDirectDrawSurface7* GetBackBuffer();
	LPDIRECTDRAWSURFACE GetBackBuffer3();
    void Flip();
    inline void DisableBufferFlip() { allowFlip=0; if (!inAWindow) { if (old) lpFrontBuffer3->SetClipper(lpClipper); else lpFrontBuffer->SetClipper(lpClipper); } }
    inline void EnableBufferFlip() { allowFlip=1; if (!inAWindow) { if (old) lpFrontBuffer3->SetClipper(NULL); else lpFrontBuffer->SetClipper(NULL); } }
    void SetViewport(int x,int y,int w,int h);
    void ResetViewport();
};

#endif

